﻿using System;
using System.Collections.Generic;
using System.IO;

namespace p2_5_1
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] encryptedWords = File.ReadAllText("encrypted.txt").Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

            Program pg = new Program(encryptedWords);
            pg.Decrypt();
        }

        int [] _encryptedCodes;
        Dictionary<int, char> _code2Char = new Dictionary<int, char>();

        public Program(string[] encryptedWords)
        {
            _encryptedCodes = new int[encryptedWords.Length];
            for (int i = 0; i < encryptedWords.Length; i ++)
            {
                _encryptedCodes[i] = Convert.ToInt32(encryptedWords[i], 2);
            }

            for (int i = (int)'A'; i <= 'Z'; i ++)
            {
                _code2Char.Add(i - 'A', (char)i);
            }

            _code2Char.Add(26, ' ');
        }

        private void Decrypt()
        {
            for (int key = 0; key < 32; key++)
            {
                bool validKey = true;

                char[] words = new char[_encryptedCodes.Length];
                for (int i = 0; i < _encryptedCodes.Length; i ++)
                {
                    char? result = Decrypt(_encryptedCodes[i], key);
                    if (result == null)
                    {
                        validKey = false;
                        break;
                    }

                    words[i] = result.Value;
                }

                if (validKey == true)
                {
                    string plain = new string(words);
                    Console.WriteLine(plain);
                }
            }
        }

        private char? Decrypt(int encryptedWord, int key)
        {
            int decryped = encryptedWord ^ key;
            if (decryped >= _code2Char.Count)
            {
                return null;
            }

            return _code2Char[decryped];
        }
    }
}
